codeforces 392 div2 D ability to convert

来源:互联网 发布:mac的pages怎么保存 编辑:程序博客网 时间:2024/05/20 22:30

D. Ability To Convert
time limit per test
1 second
memory limit per test
256 megabytes
input
standard input
output
standard output
Alexander is learning how to convert numbers from the decimal system to any other, however, he doesn’t know English letters, so he writes any number only as a decimal number, it means that instead of the letterA he will write the number 10. Thus, by converting the number 475 from decimal to hexadecimal system, he gets11311 (475 = 1·162 + 13·161 + 11·160). Alexander lived calmly until he tried to convert the number back to the decimal number system.
Alexander remembers that he worked with little numbers so he asks to find the minimum decimal number so that by converting it to the system with the basen he will get the number k.
Input
The first line contains the integer n (2 ≤ n ≤ 109). The second line contains the integerk (0 ≤ k < 1060), it is guaranteed that the numberk contains no more than 60 symbols. All digits in the second line are strictly less than n.
Alexander guarantees that the answer exists and does not exceed 1018.
The number k doesn’t contain leading zeros.
Output
Print the number x (0 ≤ x ≤ 1018) — the answer to the problem.
Examples
Input
13
12
Output
12
Input
16
11311
Output
475
Input
20
999
Output
3789
Input
17
2016
Output
594
Note
In the first example 12 could be obtained by converting two numbers to the system with base13: 12 = 12·130 or15 = 1·131 + 2·130.

题意:给定一个进制,再给定一个转化后的结果,求转化前最小的十进制数,贪心策略,从后面往前,遇到可以合并的就合并,注意位数是0的情况不可在上一个数中读过去,必须留给下一位处理。

#include <cstdio>#include <cstring>#include <iostream>#include <algorithm>#include <string>using namespace std;long long quick1(long long a,long long b){    long long ans=1;    while(b)    {        if(b&1)        {            ans=ans*a;            b--;        }        b>>=1;        a=a*a;    }    return ans;}int main(){    int n;    char c[100];    cin>>n;    cin>>c;    long long len=strlen(c);    long long now=0;    long long i;    long long ans=0;    long long f1;    for(i=len-1;i>=0;i--)    {        long long now1=c[i]-'0';        long long g=1;        f1=i;        while(i-1>=0&&now1+(c[i-1]-'0')*quick1(10,g)<n&&now1+1*quick1(10,g)<n)//确保当前位和当前位与下一位拼起来的值不大于进制        {            now1=now1+(c[i-1]-'0')*quick1(10,g); //得出这个数的十进制结果            g++;                       //g代表里面十进制的位数            i--;                    //每加一位 i--;            if(c[i]!='0')         //由于i--,所以是下一位如果不是0的话 f1=i,证明最多可以到达下一位。                f1=i;        }//直到不可再往上一位,就把当前得到的最大输出出来        i=f1; //i代表这个数可以到达的最大位数的指标        ans+=now1*quick1(n,now); //把贪心得出的结果now1乘上快速幂的次方        now++;  //now代表当前这个数的次方。    }    cout<<ans<<endl;}
0 0